/* header auto-generated by pidl */

#ifndef _PIDL_HEADER_mapistore_indexing_db
#define _PIDL_HEADER_mapistore_indexing_db

#include <util/data_blob.h>
#include <stdint.h>

#include <core/ntstatus.h>

#ifndef _HEADER_mapistore_indexing_db
#define _HEADER_mapistore_indexing_db

enum mapistore_indexing_version
#ifndef USE_UINT_ENUMS
 {
	MAPISTORE_INDEXING_VERSION_1=(int)(1)
}
#else
 { __donnot_use_enum_mapistore_indexing_version=0x7FFFFFFF}
#define MAPISTORE_INDEXING_VERSION_1 ( 1 )
#endif
;

enum mapistore_indexing_type
#ifndef USE_UINT_ENUMS
 {
	MAPISTORE_INDEXING_FOLDER=(int)(1),
	MAPISTORE_INDEXING_MESSAGE=(int)(2),
	MAPISTORE_INDEXING_SOFTDELETE=(int)(3)
}
#else
 { __donnot_use_enum_mapistore_indexing_type=0x7FFFFFFF}
#define MAPISTORE_INDEXING_FOLDER ( 1 )
#define MAPISTORE_INDEXING_MESSAGE ( 2 )
#define MAPISTORE_INDEXING_SOFTDELETE ( 3 )
#endif
;

enum mapistore_indexing_acl_type
#ifndef USE_UINT_ENUMS
 {
	MAPISTORE_ACL_NONE=(int)(1),
	MAPISTORE_ACL_READ=(int)(2),
	MAPISTORE_ACL_WRITE=(int)(3),
	MAPISTORE_ACL_RDWR=(int)(4)
}
#else
 { __donnot_use_enum_mapistore_indexing_acl_type=0x7FFFFFFF}
#define MAPISTORE_ACL_NONE ( 1 )
#define MAPISTORE_ACL_READ ( 2 )
#define MAPISTORE_ACL_WRITE ( 3 )
#define MAPISTORE_ACL_RDWR ( 4 )
#endif
;

struct mapistore_indexing_acl {
	const char *username;/* [unique,charset(UTF16)] */
	enum mapistore_indexing_acl_type acl;
}/* [public] */;

struct mapistore_indexing_acls {
	uint16_t acl_number;
	struct mapistore_indexing_acl *acls;
}/* [public] */;

union mapistore_indexing_acls_union {
	struct mapistore_indexing_acls acls_folder;/* [case(MAPISTORE_INDEXING_FOLDER)] */
}/* [switch_type(uint8)] */;

struct mapistore_indexing_allocation_range {
	uint64_t next_allocation_id;
	uint64_t last_allocation_id;
}/* [public] */;

union mapistore_indexing_alloc_range_union {
	struct mapistore_indexing_allocation_range range;/* [case(MAPISTORE_INDEXING_FOLDER)] */
}/* [switch_type(uint8)] */;

struct mapistore_indexing_info_v1 {
	const char *mapistoreURI;/* [unique,charset(UTF16)] */
	enum mapistore_indexing_type Type;
	uint64_t FMID;
	uint64_t ParentFolderID;
	union mapistore_indexing_alloc_range_union MessageRangeIDs;/* [switch_is(Type)] */
	union mapistore_indexing_acls_union Acls;/* [switch_is(Type)] */
}/* [public] */;

union mapistore_indexing_info {
	struct mapistore_indexing_info_v1 mapistore_indexing_v1;/* [case(MAPISTORE_INDEXING_VERSION_1)] */
}/* [switch_type(uint16)] */;

struct mapistore_indexing_entry {
	uint16_t version;
	union mapistore_indexing_info info;/* [switch_is(version)] */
}/* [public] */;

struct mapistore_indexing_entry_r {
	const char *indexing_key;/* [unique,charset(DOS)] */
	uint64_t FMID;
}/* [public] */;

#endif /* _HEADER_mapistore_indexing_db */
#endif /* _PIDL_HEADER_mapistore_indexing_db */
